﻿#target "illustrator"
/*
// アートボードの高さを59.972222で割って余りを等分してプロップマークを書く
// 最悪値は上記の４倍に少し足らない実行239ｍｍを3等分の79.7mmのはず
// ３倍に少し足らない実行179mmはA4=210から前後余白15mmと普通のプリンターなら考え辛いため
// クロップマーク位置データは600dpiに換算後テキストファイルに吐き出す
// クロップマークは最大20対まで


//留意点
// イラストレーターの仕様で内部的にはdoubleかつ72dpi（ポイント）で計算
//JAVAなので、絶対に整数同士の割り算はさせない＞勝手にIntに丸められることも有る
//X方向は左基準普通の座標系、Ｙ方向は上基準の座標系
//Windowsで開発しているので拡張子が有ることが前提と成っている
//ファイルに拡張子が無く上手く動かない場合は  // If  you use non extension file.'で検索して coment out endまでコメントアウトする

//The height of the Art board is equally divided the remainder was divided by 59.972222 Write a crop mark.
//Worst value should of 79.7mm of 3 equal parts execution 239mm which is not trivial little to four times above.
//For execution 179mm three times it is not trivial little painful thought if ordinary printer and margins 15mm front and back from A4 = 210.
//Crop mark position data I spit in conversion after text file in 600dpi.
//Max 20 pairs Crop mark.


//Points to remember
//Internally illustrator specification of the calculation in double and 72dpi (points)
//So JAVA, that is not the division of integer between absolute (without permission sometimes rounded to Int)
//X-direction is left reference normal coordinate system, the coordinate system in the Y direction on the basis
//The test environment is Windows with filen ame extension.
// If  you use non extension file. serch "If  you use non extension file."' and  coment out  to coment  out end.
*/

(function(){
    //start Function definition
        var SCRIPT_TITLE = 'UV tool';
        var SCRIPT_VERSION = '0.16.0';
        
        // darwing init data
        var MarkLineWith = 0.5;
        var  BGSize = 6;
         var TopMargin =4;
         var BttomMargin =4;
         var LeftMargin = 4;
         var RightMargin = 4;
         var MarkSize =4; 
        

                  
        //Calculation constants
         var STDPropIntarval = 170.0; //caution unit is point in script  59.9722…mm
         var mm = 72/25.4; //caution unit is point in script 
         var dpi = 600/72.0;
 
        var MarkLeft;
        var MarkRight;
        var MarkCount ;
        var MarkPositionY = [20];
        var DocWidth;
         var DocHeight;
        var HeightOrg;
         var WidthOrg;




	// UI Dialog
	function mainDialog() {
		this.init();
		return this;
	};

	mainDialog.prototype.init = function() {

		var unit = 20;
		var thisObj = this;

		var getSelectedIndex = function(array) {
			for (var i = 0; i < array.length; i++) {
				if(array[i].value) return i;
			}
			return -1;
		};

		thisObj.dlg = new Window('dialog', SCRIPT_TITLE + ' - ver.' + SCRIPT_VERSION);
		thisObj.dlg.margins = [unit * 1.5, unit * 1.5, unit * 1.5, unit * 1.5];
     
		thisObj.targetPanel = thisObj.dlg.add('panel', undefined, 'margin： (mm)');
		thisObj.targetPanel.alignment = 'left';
		thisObj.targetPanel.margins = [unit, unit*2, unit, unit];
		thisObj.targetPanel.orientation = 'row';
        
		thisObj.methodPanel = thisObj.dlg.add('panel', undefined, 'size： (mm)');
		thisObj.methodPanel.alignment = 'left';
		thisObj.methodPanel.margins = [unit, unit, unit, unit];
		thisObj.methodPanel.orientation = 'row';


		thisObj.buttonGroup = thisObj.dlg.add('group', undefined);
		thisObj.buttonGroup.margins = [unit, unit * 0, unit, unit * 0];
		thisObj.buttonGroup.alignment = 'center';
		thisObj.buttonGroup.orientation = 'row';

		thisObj.rdTarget  = [
            thisObj.targetPanel.add("statictext",[5,5,60,20],"TOP"),
           TopMargin = thisObj.targetPanel.add("edittext", [ 10, 10, 50, 30],TopMargin),
          thisObj.targetPanel.add("statictext",[5,5,60,20],"LEFT"),
           LeftMargin =  thisObj.targetPanel.add("edittext", [ 10, 10, 50, 30 ],LeftMargin),
            thisObj.targetPanel.add("statictext",[5,5,50,20],"RIGHT"),
			RightMargin = thisObj.targetPanel.add("edittext", [ 10, 10, 50, 30 ],RightMargin),
            thisObj.targetPanel.add("statictext",[5,5,60,20],"BTTOM"),
			BttomMargin = thisObj.targetPanel.add("edittext", [ 10, 10, 50, 30 ],BttomMargin)
            ];


		thisObj.rdMethod = [
            thisObj.methodPanel.add("statictext",[5,5,60,20],"Mark"),
            MarkSize = thisObj.methodPanel.add("edittext", [ 10, 10, 140, 30],MarkSize),
            thisObj.methodPanel.add("statictext",[5,5,60,20],"BG"),            
            BGSize= thisObj.methodPanel.add("edittext", [ 10, 10, 140, 30], BGSize)
            
		];


		thisObj.cancel = thisObj.buttonGroup.add('button', undefined, 'cancel', {name: 'cancel'});
        
		thisObj.ok = thisObj.buttonGroup.add('button', undefined, 'ok', { name:'ok'});

		thisObj.ok.onClick = function() {
		
			try {
			  TopMargin = TopMargin.text * mm ;
                LeftMargin =LeftMargin.text * mm;
                RightMargin = RightMargin.text * mm;
                BttomMargin = BttomMargin.text * mm;
                MarkSize = MarkSize.text *mm;
                BGSize =  BGSize.text *mm;
                result = drawingRegMark();
                result =saveFileMarkInfo();
                
			} catch(e) {
				alert('Stop Script by Eroor \n Eroor Infomation：' + e);
			} finally {
				thisObj.closeDialog();
			}
		}
		thisObj.cancel.onClick = function() {
			thisObj.closeDialog();
		}
	};


	mainDialog.prototype.showDialog = function() {
		this.dlg.show();
	};
	mainDialog.prototype.closeDialog = function() {
		this.dlg.close();
	};

        function saveFileMarkInfo(){


                 fileNm = app.activeDocument.name; //get current document name
                 
                if (fileNm == null)exit;

                // If  you use non extension file.  Coment out following lines. 
                point = fileNm.lastIndexOf(".");    //serch last '.'

                if (point != -1) {
                        fileNm= fileNm.substring(0, point); //trim
                    } else{
                        return(-1);
                    }
                // I Coment out end. 
                
               var fobjname = app.activeDocument.path;
                      fobjname = fobjname + "/" + fileNm  +".xml" ;
                var fileObj =  new File( fobjname);
               
                var fileRef  = fileObj.saveDlg("Input File Name");
   
            if (fileRef   != null){
               
            
                    flag = fileRef.open ("w","","");
                    docObj = activeDocument;
                    
                    if (flag){
                        
                                 fileRef.writeln("<?xml version=\"1.0\"?>\n"); //XML Header
                                 fileRef.writeln("<CropMarks>\n"); //CropMarks Entry
                                                           
                                 for ( i = 0 ; i <= MarkCount ;  i++){ 
                                     
                                        fileRef.writeln( "<Position Y=\""
                                                    + Math.round(( HeightOrg - MarkPositionY[i ]) *dpi)
                                                    + "\" X=\""
                                                    + Math.round((MarkLeft  - WidthOrg)* dpi)   //The unit conversion rounded from 72dpi to 600dpi
                                                    + "\"/>\n");
                                                    
                                        fileRef.writeln( "<Position Y=\""
                                                    + Math.round(( HeightOrg - MarkPositionY[i ]) *dpi)
                                                    + "\" X=\""
                                                    + Math.round((MarkRight  - WidthOrg)* dpi)   //The unit conversion rounded from 72dpi to 600dpi
                                                    + "\"/>\n");
      
                                  }
                                fileRef.writeln("</CropMarks>\n"); //CropMarks End
                                
                              
     
                    }
                    fileRef.close();
                }else{
                    alert("does not save file");
                }
            
        };

    
         function  getRect(){
            var doc = app.activeDocument;
            var artboards = doc.artboards;
            var artboard = artboards[artboards.getActiveArtboardIndex()];
            DocWidth = Math.abs(artboard.artboardRect[2] - artboard.artboardRect[0]);
            WidthOrg = artboard.artboardRect[0];
           
           DocHeight =  Math.abs(artboard.artboardRect[3] - artboard.artboardRect[1]);
           HeightOrg = artboard.artboardRect[1];
       
            return(0);
         };
         
      function setColor(r,g,b){
                    var tmpColor = new RGBColor();
                    tmpColor.red = r;
                    tmpColor.green = g;
                    tmpColor.blue = b;
                    return tmpColor;
        };

//The height of the Art board is equally divided the remainder was divided by 59.972222 Write a crop mark.
        function setMarkPositionY(){
          var DrowHight =  DocHeight - TopMargin - BttomMargin - MarkSize;
          MarkCount  =Math.floor( DrowHight / STDPropIntarval *1.0);
          var MarkInterval = DrowHight  / MarkCount *1.0;
  
            MarkPositionY[0] = (HeightOrg -(TopMargin + MarkSize/2.0) );
            for ( i = 1 ; i <= MarkCount ;  i++){
                MarkPositionY[i] =  MarkPositionY[i - 1] - MarkInterval;
             }
         
         MarkLeft = LeftMargin + MarkSize /2.0 +WidthOrg;
         MarkRight = DocWidth - RightMargin - MarkSize /2.0 + WidthOrg;

      /*alert("DocHeight " + DocHeight/mm +"\nDrowHight " + DrowHight/mm  +"\n MarkCount " +  MarkCount  +"\n MarkSize " +   MarkSize/mm 
          +"\n TopMargin " +   TopMargin/mm +"\n BttomMargin " +   BttomMargin/mm  + "\n MarkInterval " +MarkInterval/mm
           + "\n　MarkLeft " + MarkLeft/mm  +"\nMarkRight" + MarkRight/mm);*/
             
            return(0);
    };
    

     function  drawingPropSub(XPosition,YPosition,Size){
         
                     BlackColor = setColor(0,0,0);	//　black
                     WhiteColor = setColor(255,255,255);	//　black
                 
                    docObj = app.activeDocument;    //ellipse needs TOP  with offset,LEFT  with offset,size,size
                    
                    
                    // drawing background
                    bgObj = docObj.pathItems.ellipse(YPosition +BGSize/2.0 ,XPosition -  BGSize/2.0 ,BGSize,BGSize);
                    bgObj.filled = true;
                    bgObj.stroked = true;	//　line
                    bgObj.strokeWidth = MarkLineWith;
                    bgObj.strokeColor =  WhiteColor;
                    bgObj.fillColor = WhiteColor;


                    //drawing  crop mark Circle
                    pObj = docObj.pathItems.ellipse(YPosition +Size/2.0 ,XPosition - Size/2.0 ,Size,Size);
                    pObj.filled = false;
                    pObj.stroked = true; //line
                    pObj.strokeWidth = MarkLineWith;
                    pObj.strokeColor =  BlackColor;
                   
                    //drawing  crop mark LienX
                    var VLineMark = docObj.pathItems.add(); //line need [x1,y1],[x2,y2]  Line position               
                   VLineMark.setEntirePath( [[  XPosition - Size/2.0 ,YPosition ], [ XPosition + Size/2.0 ,YPosition, ]]);
                   VLineMark.stroked = true;
                     VLineMark.strokeWidth = MarkLineWith;
                     VLineMark.strokeColor =  BlackColor;

                 //drawing  crop mark LienY
                var HLineMaek = docObj.pathItems.add();
                   HLineMaek.setEntirePath( [[XPosition , YPosition  - Size/2.0   ], [ XPosition , YPosition  + Size/2.0 ]]);
                   HLineMaek.stroked = true;
                     HLineMaek.strokeWidth = MarkLineWith;
                     HLineMaek.strokeColor =  BlackColor;
            
         };


    
        function  drawingRegMark(){
                result = setMarkPositionY();
               for ( i = 0 ; i <= MarkCount ;  i++){
                    var CrntMarkPositionY = MarkPositionY[i ];
                     drawingPropSub(MarkLeft,CrntMarkPositionY,MarkSize);
                     drawingPropSub(MarkRight,CrntMarkPositionY,MarkSize);
             }
            
            return(0);
         };

    //End Function definition


//main
   var savedCheck = app.activeDocument.path; //get current document name for chckeing this file was saved
                 
   if (savedCheck  != ""){
            try {
                    if (app.documents.length > 0 ) {
                        //start mainfllow
                        var result = getRect(); 
                        var dialog = new mainDialog();
                       dialog.showDialog();

                       // end main fllow
                    }
                    else{
                        throw new Error('File dos not open');
                    }
                }
                catch(e) {
                    alert( e.message, "Script", true);
                }

            }else{

            alert("Save this file first");
            
           }


})()